unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, VCLUnZip, VCLZip, INIFiles, DB, Grids, DBGrids,
  dxmdaset, DateUtils, ComCtrls, kpZipObj, Buttons;

const
    ININame='Config.ini';
    BackUpVersion='1.3';

var
    IsBackUp:boolean = false;
    IsShowWindows:boolean = false;
    IsMessages:boolean = false;
    ShowMessages:boolean = false;
    IsIniFile:boolean = false;

type
  THackVCLZip = class(TVCLZip)
  end;

  TMyThread = class(TThread)
  public
    procedure Execute; override;
  end;

  TForm1 = class(TForm)
    Button1: TButton;
    mdFiles: TdxMemData;
    mdFilesFile: TStringField;
    dbgFiles: TDBGrid;
    dsFiles: TDataSource;
    eFileNameMask: TEdit;
    pbTotal: TProgressBar;
    pbFile: TProgressBar;
    Label1: TLabel;
    Button2: TButton;
    dbgNotInclude: TDBGrid;
    dsNotInclude: TDataSource;
    mdNotInclude: TdxMemData;
    mdNotIncludeFile: TStringField;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Button3: TButton;
    Label7: TLabel;
    SpeedButton1: TSpeedButton;
    Label6: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    l_PrTime: TLabel;
    l_OstTime: TLabel;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure VCLZip1TotalPercentDone(Sender: TObject; Percent: Integer);
    procedure VCLZip1ZipComplete(Sender: TObject; FileCount: Integer);
    procedure VCLZip1FilePercentDone(Sender: TObject; Percent: Integer);
    procedure Button2Click(Sender: TObject);
    procedure VCLZip1StartZip(Sender: TObject; FName: String;
      var ZipHeader: TZipHeaderInfo; var Skip: Boolean);
    procedure Button3Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure dbgFilesKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure dbgFilesEditButtonClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    BeginTime:TDateTime;
    StrNotInclude:TStrings;
    ZipAction:integer;
    { Private declarations }
  public
    VCLZip1: THackVCLZip;
    procedure SaveIni;
    procedure LoadIni;
    { Public declarations }
  end;

function ConvertMaskedString(str:string; ADate:TDateTime=0):string;

var
  Form1: TForm1;
  INIPathFile:string;
  CDir:string;
var
  thr:TMyThread = nil;

implementation

{$R *.dfm}

uses unit2, Masks, Unit3, Unit4, Unit5, Types;

function foxstr(i,l:integer;c:char=' '):string;
var s:string;
    k:integer;
begin
     s:=inttostr(i);
     if length(s)<l then
        begin
             for k:=1 to l-length(s) do
                 s:=c+s;
        end;
     result:=s;
end;

function ReplaceStr(s,s_find,s_replace:string):string;
begin
    if pos(s_find,s)>0 then
        result:=copy(s,1,pos(s_find,s)-1)+s_replace+copy(s,pos(s_find,s)+length(s_find),length(s)-(pos(s_find,s)+length(s_find))+1)
    else
        result:=s;
end;

function ReplaceStrAll(s,s_find,s_replace:string):string;
var sss,sss1:string;
begin
    if pos(s_find,s_replace)>0 then
        result:=''
    else
        begin
            sss1:=s;
            sss:=ReplaceStr(sss1,s_find,s_replace);
            while sss1<>sss do
                begin
                    sss1:=sss;
                    sss:=ReplaceStr(sss1,s_find,s_replace);
                end;
            result:=sss;
        end;
end;

{-----------------------------------------------------------------------------
  Procedure: ConvertMaskedString
  Author:    Baryshev
  Date:      17:23:23 23.07.2003
  Arguments: str:string
  Result:    string
  Remarks:
      str 
      %yyyy%    -  4 ;
      %yyy%     -  3  ;
      %yy%      -  2  ;
      %y%       -  1  ;
      %my%      -  2 ;
      %dd%      -  2 ;
      %hh%      -  2 ;
      %mm%      -  2 ;
      %ss%      -  2 ;
      %wm%      -   1 ;
      %wy%      -   2 ;
      %qwart%   -  1 ;
      %qwartr%  -  ;
      %qwartr3% -   3 ;
      %dcht%    -   (1- , 2-)
      %mcht%    -   (1- , 2-)
      %ycht%    -   (1- , 2-)
-----------------------------------------------------------------------------}
function ConvertMaskedString(str:string; ADate:TDateTime=0):string;
var
    yyyy,my,dd,hh,mm,ss,wm,wy,qwart,qwartr,qwartr3,dcht,mcht,ycht:string;
    AYear, AMonth, ADay, AHour, AMinute, ASecond, AMilliSecond: Word;
    NowDT:TDateTime;
begin
    if ADate=0 then
        NowDT:=Now
    else
        NowDT:=ADate;
    DecodeDateTime(NowDT, AYear, AMonth, ADay, AHour, AMinute, ASecond, AMilliSecond);
    wm:=foxstr(WeekOfTheMonth(NowDT),1,'0');
    wy:=foxstr(WeekOfTheYear(NowDT),2,'0');
    dcht:=inttostr(1-(ADay mod 2)+1);
    mcht:=inttostr(1-(AMonth mod 2)+1);
    ycht:=inttostr(1-(AYear mod 2)+1);
    case AMonth of
    1..3:
        begin
            qwart:='1';
            qwartr:='I';
            qwartr3:='  I';
        end;
    4..6:
        begin
            qwart:='2';
            qwartr:='II';
            qwartr3:=' II';
        end;
    7..9:
        begin
            qwart:='3';
            qwartr:='III';
            qwartr3:='III';
        end;
    10..12:
        begin
            qwart:='4';
            qwartr:='IV';
            qwartr3:=' IV';
        end;
    end;
    yyyy:=foxstr(AYear,4,'0');
    my:=foxstr(AMonth,2,'0');
    dd:=foxstr(ADay,2,'0');
    hh:=foxstr(AHour,2,'0');
    mm:=foxstr(AMinute,2,'0');
    ss:=foxstr(ASecond,2,'0');
    Result:=str;
    Result:=ReplaceStrAll(Result,'%yyyy%',yyyy);
    Result:=ReplaceStrAll(Result,'%yyy%',copy(yyyy,2,3));
    Result:=ReplaceStrAll(Result,'%yy%',copy(yyyy,3,2));
    Result:=ReplaceStrAll(Result,'%y%',copy(yyyy,4,1));
    Result:=ReplaceStrAll(Result,'%my%',my);
    Result:=ReplaceStrAll(Result,'%dd%',dd);
    Result:=ReplaceStrAll(Result,'%hh%',hh);
    Result:=ReplaceStrAll(Result,'%mm%',mm);
    Result:=ReplaceStrAll(Result,'%ss%',ss);

    Result:=ReplaceStrAll(Result,'%wm%',wm);
    Result:=ReplaceStrAll(Result,'%wy%',wy);
    Result:=ReplaceStrAll(Result,'%qwart%',qwart);
    Result:=ReplaceStrAll(Result,'%qwartr%',qwartr);
    Result:=ReplaceStrAll(Result,'%qwartr3%',qwartr3);
    Result:=ReplaceStrAll(Result,'%dcht%',dcht);
    Result:=ReplaceStrAll(Result,'%mcht%',mcht);
    Result:=ReplaceStrAll(Result,'%ycht%',ycht);

end;

procedure TForm1.Button1Click(Sender: TObject);
var
    FName:string;
    bm:pointer;
begin
    if not self.VCLZip1.Busy then
        begin
            self.SaveIni;
            self.StrNotInclude.Clear;
            bm:=self.mdNotInclude.GetBookmark;
            self.mdNotInclude.DisableControls;
            self.mdNotInclude.First;
            while not self.mdNotInclude.Eof do
                begin
                    self.StrNotInclude.Add(self.mdNotIncludeFile.Value);
                    self.mdNotInclude.Next;
                end;
            self.mdNotInclude.GotoBookmark(bm);
            self.mdNotInclude.EnableControls;
            self.mdNotInclude.FreeBookmark(bm);

            bm:=self.mdFiles.GetBookmark;
            self.mdFiles.DisableControls;
            self.mdFiles.First;
            while not self.mdFiles.Eof do
                begin
                    self.VCLZip1.FilesList.Add(self.mdFilesFile.AsString);
                    self.mdFiles.Next;
                end;
            self.mdFiles.GotoBookmark(bm);
            self.mdFiles.EnableControls;
            self.mdFiles.FreeBookmark(bm);

            FName:=ConvertMaskedString(self.eFileNameMask.Text);
            self.VCLZip1.ZipName:=FName;
            self.Label7.Caption:=FName;
            ForceDirectories(ExtractFilePath(FName));
            BeginTime:=Now;
            if (ZipAction<0) or (ZipAction>3) then
                begin
                    ZipAction:=2;
                end;
            case ZipAction of
            0:
                begin
                    if FileExists(self.VCLZip1.ZipName) then
                        DeleteFile(self.VCLZip1.ZipName);
                    self.VCLZip1.ZipAction:=zaReplace;
                end;
            1:
                begin
                    self.VCLZip1.ZipAction:=zaUpdate;
                end;
            2:
                begin
                    self.VCLZip1.ZipAction:=zaReplace;
                end;
            3:
                begin
                    self.VCLZip1.ZipAction:=zaFreshen;
                end;
            end;
            //self.VCLZip1.StoreVolumes:=true;     (   ,  WinRAR )
            //self.VCLZip1.Dispose:=true;    
            //self.VCLZip1.Recurse:=true;  
            self.VCLZip1.Zip;
        end;
end;

procedure TForm1.LoadIni;
var ini:TINIFile;
    str:TStrings;
begin
    while self.mdFiles.RecordCount>0 do
        begin
            self.mdFiles.Delete;
        end;
    while self.mdNotInclude.RecordCount>0 do
        begin
            self.mdNotInclude.Delete;
        end;
    str:=TStringList.Create;
    ini:=TINIFile.Create(INIPathFile);
    if ini.ReadString('Config','Version','1.0')='1.0' then
        self.eFileNameMask.Text:=ReplaceStrAll(ini.ReadString('Config','ZipName','C:\BackUp\%yyyy%%MM%%dd%%hh%%mm%%ss%.zip'),'%MM%','%my%')
    else
        self.eFileNameMask.Text:=ini.ReadString('Config','ZipName','C:\BackUp\%yyyy%%my%%dd%%hh%%mm%%ss%.zip');
    self.VCLZip1.PackLevel:=ini.ReadInteger('Config','Level',6);
    self.VCLZip1.Recurse:=ini.ReadBool('Config','IncludeSubDirs',true);
    self.VCLZip1.StorePaths:=ini.ReadBool('Config','StorePaths',true);
    ZipAction:=ini.ReadInteger('Config','ZipAction',2);
    if (ZipAction<0) or (ZipAction>3) then
        begin
            ZipAction:=2;
        end;
    ini.ReadSection('Files',str);
    while str.Count>0 do
        begin
            self.mdFiles.Append;
            self.mdFilesFile.AsString:=ini.ReadString('Files',str.Strings[0],'');
            self.mdFiles.Post;
            str.Delete(0);
        end;
    str.Clear;
    ini.ReadSection('FilesNotInclude',str);
    while str.Count>0 do
        begin
            self.mdNotInclude.Append;
            self.mdNotIncludeFile.AsString:=ini.ReadString('FilesNotInclude',str.Strings[0],'');
            self.mdNotInclude.Post;
            str.Delete(0);
        end;
    ini.Destroy;
    str.Destroy;
end;

procedure TForm1.SaveIni;
var ini:TINIFile;
    i:integer;
    str:TStrings;
begin
    str:=TStringList.Create;
    ini:=TINIFile.Create(INIPathFile);
    ini.WriteString('Config','ZipName',self.eFileNameMask.Text);
    ini.WriteString('Config','Version',BackUpVersion);
    ini.WriteInteger('Config','Level',self.VCLZip1.PackLevel);
    ini.WriteBool('Config','IncludeSubDirs',self.VCLZip1.Recurse);
    ini.WriteBool('Config','StorePaths',self.VCLZip1.StorePaths);
    if (ZipAction<0) or (ZipAction>3) then
        begin
            ZipAction:=2;
        end;
    ini.WriteInteger('Config','ZipAction',ZipAction);
    ini.ReadSection('Files',str);
    while str.Count>0 do
        begin
            ini.DeleteKey('Files',str.Strings[0]);
            str.Delete(0);
        end;
    i:=0;
    self.mdFiles.First;
    while not self.mdFiles.Eof do
        begin
            i:=i+1;
            ini.WriteString('Files',inttostr(i),self.mdFilesFile.AsString);
            self.mdFiles.Next;
        end;
    self.mdFiles.First;
    str.Clear;
    ini.ReadSection('FilesNotInclude',str);
    while str.Count>0 do
        begin
            ini.DeleteKey('FilesNotInclude',str.Strings[0]);
            str.Delete(0);
        end;
    i:=0;
    self.mdNotInclude.First;
    while not self.mdNotInclude.Eof do
        begin
            i:=i+1;
            ini.WriteString('FilesNotInclude',inttostr(i),self.mdNotIncludeFile.AsString);
            self.mdNotInclude.Next;
        end;
    self.mdNotInclude.First;

    ini.Destroy;
    str.Destroy;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
    VCLZip1:=THackVCLZip.Create(self);
    self.VCLZip1.AddDirEntriesOnRecurse:=false;
    self.VCLZip1.Recurse:=true;
    self.VCLZip1.RelativePaths:=true;
    self.VCLZip1.ReplaceReadOnly:=true;
    VCLZip1.OnTotalPercentDone:=VCLZip1TotalPercentDone;
    VCLZip1.OnZipComplete:=VCLZip1ZipComplete;
    VCLZip1.OnFilePercentDone:=VCLZip1FilePercentDone;
    VCLZip1.OnStartZip:=VCLZip1StartZip;
    CDir:=ExtractFilePath(Application.ExeName);
    self.StrNotInclude:=TStringList.Create;
    self.LoadIni;
    if IsBackUp then
        begin
            if not IsShowWindows then
                begin
                    Form1.Visible:=false;
                    self.Button1Click(self.Button1);
                end;
        end;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
    if self.VCLZip1.Busy then
        begin
            CanClose:=false;
        end
    else
        begin
            self.SaveIni;
        end;
end;

procedure TForm1.VCLZip1TotalPercentDone(Sender: TObject;
  Percent: Integer);
var
    secv:Integer;
    seco:Integer;
    sv_ch,sv_min,sv_sec:string;
    so_ch,so_min,so_sec:string;
    perc:extended;
begin
    self.pbTotal.Position:=Percent;
    if VCLZip1.TotalUncompressedSize<>0 then
        perc:=self.VCLZip1.TotalBytesDone/self.VCLZip1.TotalUncompressedSize
    else
        perc:=0;
    if perc>1 then
        perc:=1;
    if perc<0.01 then
        perc:=0;

    secv:=SecondsBetween(Now,BeginTime);
    if perc>0 then
        begin
            seco:=Round(secv*(1-Perc)/Perc);
            so_sec:=IntToStr(seco mod 60);
            seco:=seco div 60;
            so_min:=IntToStr(seco mod 60);
            seco:=seco div 60;
            so_ch:=IntToStr(seco);
            self.l_OstTime.Caption:=so_ch+' . '+so_min+' . '+so_sec+' .';
        end
    else
        begin
            self.l_OstTime.Caption:='';
        end;
    sv_sec:=IntToStr(secv mod 60);
    secv:=secv div 60;
    sv_min:=IntToStr(secv mod 60);
    secv:=secv div 60;
    sv_ch:=IntToStr(secv);
    self.l_PrTime.Caption:=sv_ch+' . '+sv_min+' . '+sv_sec+' .';
end;

procedure TForm1.VCLZip1FilePercentDone(Sender: TObject; Percent: Integer);
begin
    self.pbFile.Position:=Percent;
end;

procedure TForm1.VCLZip1ZipComplete(Sender: TObject; FileCount: Integer);
begin
    self.l_PrTime.Caption:='';
    self.l_OstTime.Caption:='';
    self.pbTotal.Position:=0;
    self.pbFile.Position:=0;
    self.Label1.Caption:='';
    self.Label7.Caption:='';
    if IsBackUp then
        begin
            if ShowMessages then
                MessageDlg(' ', mtCustom, [mbOK], 0);
            PostMessage(self.Handle,WM_CLOSE,0,0);
        end
    else
        MessageDlg(' ', mtCustom, [mbOK], 0);

end;

procedure TForm1.Button2Click(Sender: TObject);
begin
    if IsBackUp then
    begin
        if not ShowMessages then
            try
                self.VCLZip1.CancelTheOperation;
            except
            end
        else
            self.VCLZip1.CancelTheOperation;
        PostMessage(self.Handle,WM_CLOSE,0,0);
    end
    else
        self.VCLZip1.CancelTheOperation;
    self.pbTotal.Position:=0;
    self.pbFile.Position:=0;
    self.Label1.Caption:='';
    self.Label7.Caption:='';
    self.l_PrTime.Caption:='';
    self.l_OstTime.Caption:='';
end;

procedure TForm1.VCLZip1StartZip(Sender: TObject; FName: String;
  var ZipHeader: TZipHeaderInfo; var Skip: Boolean);
var i:integer;
begin
    for i:= 0 to self.StrNotInclude.Count-1 do
        begin
            if MatchesMask(FName,self.StrNotInclude.Strings[i]) then
                Skip:=true;
        end;
    if not Skip then
        begin
            self.Label1.Caption:=FName;
        end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
    if not IsBackUp then
        unit2.About.ShowModal;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
    Form4.Edit1.Text:=self.eFileNameMask.Text;
    if Form4.ShowModal=mrOk then
        begin
            self.eFileNameMask.Text:=Form4.Edit1.Text;
        end;
end;

procedure TForm1.dbgFilesKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if (ssCtrl in Shift) and (Key=VK_DELETE) then
        Key:=0;
    if (Shift=[]) and (Key=VK_DELETE) then
        begin
            if not (Sender as TDBGrid).EditorMode then
                begin
                if ((Sender as TDBGrid).DataSource.DataSet.RecordCount>0) or
                 ((Sender as TDBGrid).DataSource.DataSet.State in [dsInsert, dsEdit]) then
                    if MessageDlg(' ?', mtConfirmation, [mbYes,mbNo], 0) = mrYes then
                        (Sender as TDBGrid).DataSource.DataSet.Delete;
                end;
        end;   
end;

procedure TForm1.dbgFilesEditButtonClick(Sender: TObject);
var dbg:TDBGrid;
begin
    dbg:=(Sender as TDBGrid);
    Form3.Dir:=ExtractFilePath(dbg.SelectedField.AsString);
    if Form3.ShowModal=mrOk then
        begin
            if not (dbg.DataSource.DataSet.State in [dsEdit, dsInsert]) then
                dbg.DataSource.DataSet.Edit;
            if ExtractFileName(dbg.SelectedField.AsString)<>'' then
                dbg.SelectedField.AsString:=Form3.Dir+'\'+ExtractFileName(dbg.SelectedField.AsString)
            else
                dbg.SelectedField.AsString:=Form3.Dir+'\*.*';
        end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
    if thr<>nil then
        begin
            thr.DoTerminate;
            thr.Destroy;
            thr:=nil;
        end;
    self.VCLZip1.Destroy;
    self.StrNotInclude.Destroy;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
    if not IsBackUp then
        begin
            if (ZipAction<0) or (ZipAction>3) then
                begin
                    ZipAction:=2;
                end;
            Form5.rgReplaceMode.ItemIndex:=ZipAction;
            Form5.SpinEdit1.Value:=self.VCLZip1.PackLevel;
            Form5.cbIncludeSubDirs.Checked:=self.VCLZip1.Recurse;
            Form5.cbStorePaths.Checked:=self.VCLZip1.StorePaths;
            if Form5.ShowModal=mrOk then
                begin
                    self.VCLZip1.PackLevel:=Form5.SpinEdit1.Value;
                    self.VCLZip1.Recurse:=Form5.cbIncludeSubDirs.Checked;
                    self.VCLZip1.StorePaths:=Form5.cbStorePaths.Checked;
                    ZipAction:=Form5.rgReplaceMode.ItemIndex;
                    if (ZipAction<0) or (ZipAction>3) then
                        begin
                            ZipAction:=2;
                        end;
                end;
        end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
    if IsBackUp then
        begin
            if IsShowWindows then
                begin
                    thr:=TMyThread.Create(false);
                end;
        end;
end;

procedure TMyThread.Execute;
begin
    form1.Button1Click(form1.Button1);
end;

end.
